labo02/app/routes/web.php
<?php

use App\Http\Controllers\FiddleController;
use App\Http\Controllers\BlogController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
/*
Route::get('/', function () {
    return view('welcome');
});
*/
Route::get('fiddleone', [FiddleController::class, 'one']);
Route::get('fiddletwo', [FiddleController::class, 'two']);
Route::get('fiddlethree', [FiddleController::class, 'three']);
Route::get('fiddlefour', [FiddleController::class, 'four']);
Route::get('fiddlefive', [FiddleController::class, 'five']);
Route::get('fiddlesix', [FiddleController::class, 'six']);
Route::get('fiddleseven', [FiddleController::class, 'seven']);
Route::get('fiddleeight', [FiddleController::class, 'eight']);
Route::get('fiddlenine', [FiddleController::class, 'nine']);
Route::get('fiddleten', [FiddleController::class, 'ten']);
Route::get('fiddleeleven', [FiddleController::class, 'eleven']);
Route::get('test/{id}', [FiddleController::class, 'test']);

Route::get('/', [BlogController::class,'home']);
Route::get('blogposts/{id}', [BlogController::class, 'blogpost'])->where(['id' => '[0-9]+']);
Route::get('blogposts/add', [BlogController::class,'add']);
Route::get('blogposts/search', [BlogController::class, 'search']);
Route::get('categories/{category}', [BlogController::class,'category']);
Route::get('authors/{id}', [BlogController::class, 'author'])->where(['id' => '[0-9]+']);

Route::post('blogposts/add', [BlogController::class,'store']);
Route::post('blogposts/search', [BlogController::class, 'searchThis']);

labo02/app/app/Models/Author.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Author extends Model
{
    use HasFactory;

    protected $fillable = ['first_name', 'last_name', 'email', 'website', 'location', 'updated_at'];
    //protected $hidden = ['id', 'created_at'];

    public function blogposts(){
        return $this->hasMany(Blogpost::class);
    }

    public function comments(){
        return $this->hasMany(Comment::class);
    }

    public function getFullNameAttribute(){
        return $this->first_name . ' ' . $this->last_name;
    }
}

labo02/app/resources/views/add-with-tags.blade.php
@extends('master')
@section('title', 'Blogotopia | Add a blogpost')
@section('main')
    <main class="container">
        <div class="row g-5">
            <div class="col-md-8">
                <div class="p-4 mb-3 bg-light rounded">
                    <h4 class="mb-3">Add a blogpost</h4>
                    @include('common.errors')
                    @foreach($errors->getMessages() as $key => $message)
                        {{$errorArray[] = $key}}
                    @endforeach

                    {{--@if($errors->any())
                        {{ dump($errors->default) }}
                        @foreach($errors->getMessages() as $key => $message)
                            {{$errorArray[] = $key}}
                        @endforeach
                        {{ dump(in_array('title', $errorArray)) }}
                        {{ dump(session()->get('_old_input.title')) }}
                        {{ dd(session() -> all()) }}
                    @endif--}}
                    <form class="needs-validation" novalidate="" method="post" action="{{ url('blogposts/add') }}"
                          enctype="multipart/form-data">
                    @csrf
                    <!--<input type="hidden" name="_token" value="xbleOu1XHjw4MyI2FeAg5VzncRFBmSWuSE9dJk9D">-->
                        <div class="row g-3">
                            <!--div class="col-sm-6">
                                <label for="firstName" class="form-label">First name</label>
                                <input type="text" class="form-control is-invalid" id="firstName" placeholder="" value="" required="">
                                <div class="invalid-feedback">
                                    Valid first name is required.
                                </div>
                            </div>
                            <div class="col-sm-6">
                                <label for="lastName" class="form-label">Last name</label>
                                <input type="text" class="form-control is-valid" id="lastName" placeholder="" value="" required="">
                                <div class="valid-feedback">
                                    Looks good!
                                </div>
                            </div-->

                            <div class="col-12">
                                <label for="title" class="form-label">Title</label>
                                <input type="text"
                                       class="form-control {{ session()->exists('_old_input.title') ? (in_array('title', $errorArray) ? 'is-invalid' : 'is-valid')  : '' }}"
                                       id="title" placeholder="" name="title" value="{{ old('title', '') }}">

                            </div>

                            <div class="col-12">
                                <label for="content" class="form-label">Content</label>
                                <textarea
                                    class="form-control {{ session()->exists('_old_input.content') ? (in_array('content', $errorArray) ? 'is-invalid' : 'is-valid')  : '' }}"
                                    id="content" rows="4" name="content">{{ old('content', '') }}</textarea>
                            </div>

                            <div class="col-12">
                                <label for="image" class="form-label">Image</label>
                                <input
                                    class="form-control {{ isset($errorArray) ? (in_array('image', $errorArray) ? 'is-invalid' : '') : '' }}"
                                    type="file" id="image" name="image">
                            </div>
                        </div>

                        <hr class="my-4">


                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="featured" name="featured"
                                   @if(old('featured')) checked @endif>
                            <label class="form-check-label" for="featured">Include this blogpost on the home
                                page</label>
                        </div>

                        <hr class="my-4">

                        <div class="row g-3">
                            <div class="col-md-6">
                                <label for="category" class="form-label">Category</label>
                                <select class="form-select {{ session()->exists('_old_input.category_id') ? (in_array('category_id', $errorArray) ? 'is-invalid' : 'is-valid')  : '' }}" id="category" required="" name="category_id">
                                    <option value="">Choose...</option>
                                    @foreach($categories as $choseCategory)
                                        @if (intval(old('category_id')) === $choseCategory->id)
                                            <option value="{{ $choseCategory->id }}"
                                                    selected>{{ $choseCategory->title }}</option>
                                        @else
                                            <option
                                                value="{{ $choseCategory->id }}">{{ $choseCategory->title }}</option>
                                        @endif
                                    @endforeach
                                </select>
                            </div>

                            <div class="col-md-6">
                                <label for="author" class="form-label">Author</label>
                                <select class="form-select {{ session()->exists('_old_input.author_id') ? (in_array('author_id', $errorArray) ? 'is-invalid' : 'is-valid')  : '' }}" id="author" required="" name="author_id">
                                    <option value="">Choose...</option>
                                    @foreach($authors as $choseAuthor)
                                        @if(intval(old('author_id')) === $choseAuthor->id)
                                            <option value="{{ $choseAuthor->id }}"
                                                    selected>{{ $choseAuthor->full_name }}</option>
                                        @else
                                            <option
                                                value="{{ $choseAuthor->id }}">{{ $choseAuthor->full_name }}</option>
                                        @endif
                                    @endforeach
                                </select>
                            </div>
                            <div class="col-12">
                                <label for="tags" class="form-label">Tags</label>
                                <input type="text" class="form-control" id="tags" placeholder="" name="tags" value="{{ old('tags', '') }}">
                            </div>
                        </div>

                        <hr class="my-4">

                        <button class="btn btn-primary btn-lg" type="submit">Add blogpost</button>
                    </form>

                </div>

            </div>
            @include('sidebar')
        </div>
    </main>
@endsection

labo02/app/resources/views/add.blade.php
@extends('master')
@section('title', 'Blogotopia | Add a blogpost')
@section('main')
    <main class="container">
        <div class="row g-5">
            <div class="col-md-8">
                <div class="p-4 mb-3 bg-light rounded">
                    <h4 class="mb-3">Add a blogpost</h4>
                    @include('common.errors')
                    @foreach($errors->getMessages() as $key => $message)
                        {{$errorArray[] = $key}}
                    @endforeach

                    {{--@if($errors->any())
                        {{ dump($errors->default) }}
                        @foreach($errors->getMessages() as $key => $message)
                            {{$errorArray[] = $key}}
                        @endforeach
                        {{ dump(in_array('title', $errorArray)) }}
                        {{ dump(session()->get('_old_input.title')) }}
                        {{ dd(session() -> all()) }}
                    @endif--}}
                    <form class="needs-validation" novalidate="" method="post" action="{{ url('blogposts/add') }}"
                          enctype="multipart/form-data">
                    @csrf
                    <!--<input type="hidden" name="_token" value="xbleOu1XHjw4MyI2FeAg5VzncRFBmSWuSE9dJk9D">-->
                        <div class="row g-3">
                            <!--div class="col-sm-6">
                                <label for="firstName" class="form-label">First name</label>
                                <input type="text" class="form-control is-invalid" id="firstName" placeholder="" value="" required="">
                                <div class="invalid-feedback">
                                    Valid first name is required.
                                </div>
                            </div>
                            <div class="col-sm-6">
                                <label for="lastName" class="form-label">Last name</label>
                                <input type="text" class="form-control is-valid" id="lastName" placeholder="" value="" required="">
                                <div class="valid-feedback">
                                    Looks good!
                                </div>
                            </div-->

                            <div class="col-12">
                                <label for="title" class="form-label">Title</label>
                                <input type="text"
                                       class="form-control {{ session()->exists('_old_input.title') ? (in_array('title', $errorArray) ? 'is-invalid' : 'is-valid')  : '' }}"
                                       id="title" placeholder="" name="title" value="{{ old('title', '') }}">

                            </div>

                            <div class="col-12">
                                <label for="content" class="form-label">Content</label>
                                <textarea
                                    class="form-control {{ session()->exists('_old_input.content') ? (in_array('content', $errorArray) ? 'is-invalid' : 'is-valid')  : '' }}"
                                    id="content" rows="4" name="content">{{ old('content', '') }}</textarea>
                            </div>

                            <div class="col-12">
                                <label for="image" class="form-label">Image</label>
                                <input
                                    class="form-control {{ isset($errorArray) ? (in_array('image', $errorArray) ? 'is-invalid' : '') : '' }}"
                                    type="file" id="image" name="image">
                            </div>
                        </div>

                        <hr class="my-4">


                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="featured" name="featured"
                                   @if(old('featured')) checked @endif>
                            <label class="form-check-label" for="featured">Include this blogpost on the home
                                page</label>
                        </div>

                        <hr class="my-4">

                        <div class="row g-3">
                            <div class="col-md-6">
                                <label for="category" class="form-label">Category</label>
                                <select class="form-select {{ session()->exists('_old_input.category_id') ? (in_array('category_id', $errorArray) ? 'is-invalid' : 'is-valid')  : '' }}" id="category" required="" name="category_id">
                                    <option value="">Choose...</option>
                                    @foreach($categories as $choseCategory)
                                        @if (old('category_id') == $choseCategory->id)
                                            <option value="{{ $choseCategory->id }}"
                                                    selected>{{ $choseCategory->title }}</option>
                                        @else
                                            <option
                                                value="{{ $choseCategory->id }}">{{ $choseCategory->title }}</option>
                                        @endif
                                    @endforeach
                                </select>
                            </div>

                            <div class="col-md-6">
                                <label for="author" class="form-label">Author</label>
                                <select class="form-select {{ session()->exists('_old_input.author_id') ? (in_array('author_id', $errorArray) ? 'is-invalid' : 'is-valid')  : '' }}" id="author" required="" name="author_id">
                                    <option value="">Choose...</option>
                                    @foreach($authors as $choseAuthor)
                                        @if(old('author_id') == $choseAuthor->id)
                                            <option value="{{ $choseAuthor->id }}"
                                                    selected>{{ $choseAuthor->full_name }}</option>
                                        @else
                                            <option
                                                value="{{ $choseAuthor->id }}">{{ $choseAuthor->full_name }}</option>
                                        @endif
                                    @endforeach
                                </select>
                            </div>
                        </div>

                        <hr class="my-4">

                        <button class="btn btn-primary btn-lg" type="submit">Add blogpost</button>
                    </form>

                </div>

            </div>
            @include('sidebar')
        </div>
    </main>
@endsection

labo02/app/resources/views/author.blade.php
@extends('master')
@section('title', 'Blogotopia | '.$author[0]->full_name)
@section('main')
    <main class="container">
        <div class="row g-5">
            <div class="col-md-8">
                <h3 class="pb-4 mb-4 fst-italic border-bottom">
                    Blogposts by {{ $author[0]->full_name }}
                </h3>
                <div class="p-4 mb-3 bg-light rounded">
                    <h4 class="fst-italic">About {{ $author[0]->full_name }}</h4>
                    <p class="mb-0">
                        {{ $author[0]->full_name.' lives at '.$author[0]->location.'.' }}
                        You can find more information about {{ $author[0]->first_name }} on <a href="{{ url($author[0]->website) }}">{{ $author[0]->website }}</a>.
                    </p>
                </div>
                @foreach($authorBlogposts as $authorBlogpost)
                <article class="blog-post">
                    <h2 class="blog-post-title">{{ $authorBlogpost->title }}</h2>
                    <p class="blog-post-meta">{{ $authorBlogpost->created_at }} by <a href="{{ url('authors/'.$author[0]->id) }}">{{ $author[0]->full_name }}</a></p>
                    <p><img src="{{ asset('storage/'.$authorBlogpost->image) }}" class="rounded"
                            alt="{{ $authorBlogpost->title }}">
                    </p>
                    <p>{{ $authorBlogpost->content }}</p>
                    <a href="{{ url('blogposts/'.$authorBlogpost->id) }}">Read comments &hellip;</a>
                </article>
                @endforeach
            </div>
            @include('sidebar')
        </div>
    </main>
@endsection

labo02/app/resources/views/blogpost.blade.php
@extends('master')
@section('title', 'Blogotopia | '.$idBlogpost[0]->title)
@section('main')
    <main class="container">
        <div class="row g-5">
            <div class="col-md-8">
                <article class="blog-post">
                    <h2 class="blog-post-title">{{ $idBlogpost[0]->title }}</h2>
                    <p class="blog-post-meta">{{ $idBlogpost[0]->created_at }} by <a
                            href="{{ url('authors/'.$idBlogpost[0]->author->id) }}">{{ $idBlogpost[0]->author->full_name }}</a></p>
                    <p><img src="{{ asset('storage/'.$idBlogpost[0]->image) }}"
                            class="rounded" alt="{{ $idBlogpost[0]->title }}">
                    </p>
                    <p>{{ $idBlogpost[0]->content }}</p>
                    <h3>Comments</h3>
                    @foreach($commentsIdBlogpost as $commentIdBlogpost)
                    <p><strong>{{ $commentIdBlogpost->author->full_name }}</strong> &bullet; <em>{{ $commentIdBlogpost->created_at }}</em>{{ $commentIdBlogpost->content }}</p>
                    @endforeach
                </article>

            </div>

            @include('sidebar')
        </div>
    </main>
@endsection

labo02/app/resources/views/category.blade.php
@extends('master')
@section('title', 'Blogotopia | '.$category)
@section('main')
    <main class="container">
        <div class="row g-5">
            <div class="col-md-8">
                <h3 class="pb-4 mb-4 fst-italic border-bottom">
                    {{ ucfirst($category) }}
                </h3>
                @foreach($categoryBlogposts as $categoryBlogpost)
                <article class="blog-post">
                    <h2 class="blog-post-title">{{ $categoryBlogpost->title }}</h2>
                    <p class="blog-post-meta">{{ $categoryBlogpost->created_at }} by <a href="{{ url('authors/'.$categoryBlogpost->author->id) }}">{{ $categoryBlogpost->author->full_name }}</a></p>
                    <p><img src="{{ asset('storage/'.$categoryBlogpost->image) }}" class="rounded"
                            alt="{{ $categoryBlogpost->title }}">
                    </p>
                    <p>{{ $categoryBlogpost->content }}</p>
                    <a href="{{ url('blogposts/'.$categoryBlogpost->id) }}">Read comments &hellip;</a>
                </article>
                @endforeach
            </div>

            @include('sidebar')
        </div>
    </main>
@endsection

labo02/app/resources/views/homepage.blade.php
@extends('master')
@section('title', 'Blogotopia')
@section('main')
    <main class="container">
        @if($featuredBlogposts)
        <div class="p-4 p-md-5 mb-4 text-white rounded bg-dark banner"
             style="background-image: linear-gradient(180deg, rgba(255,255,255,0) 0, rgba(0,0,0,0.35) 0), url({{'storage/'.$featuredBlogposts[0]->image}});">
            <div class="col-md-6 px-0">
                <h1 class="display-4 fst-italic">{{ $featuredBlogposts[0]->title }}</h1>
                <p class="lead my-3">{{ $featuredBlogposts[0]->content }}</p>
                <p class="lead mb-0"><a href="{{ url('blogposts/'.$featuredBlogposts[0]->id) }}" class="text-white fw-bold">Continue reading...</a></p>
            </div>
        </div>

        <div class="row mb-2">
            @for($i = 1; $i < count($featuredBlogposts); $i++)
            <div class="col-md-6">
                <div
                    class="row g-0 border rounded overflow-hidden flex-md-row mb-4 shadow-sm h-md-250 position-relative">
                    <div class="col p-4 d-flex flex-column position-static">
                        <strong class="d-inline-block mb-2 category-2">{{ $featuredBlogposts[$i]->category->title }}</strong>
                        <h3 class="mb-0">{{ $featuredBlogposts[$i]->title }}</h3>
                        <div class="mb-1 text-muted">{{ $featuredBlogposts[$i]->created_at }}</div>
                        <p class="card-text mb-auto">{{ $featuredBlogposts[$i]->content }}</p>
                        <a href="{{ url('blogposts/'.$featuredBlogposts[$i]->id) }}" class="stretched-link">Continue reading</a>
                    </div>
                    <div class="col-auto d-none d-lg-block img-container">
                        <img src="{{ asset('storage/'.$featuredBlogposts[$i]->image) }}"
                             alt="{{ $featuredBlogposts[$i]->title }}"/>
                    </div>
                </div>
            </div>
            @endfor
        </div>
        @else
        <p>no blogposts available</p>
        @endif
    </main>
@endsection

labo02/app/resources/views/search.blade.php
@extends('master')
@section('title', 'Blogotopia')
@section('main')
    <main class="container">

        <div class="row p-4 m-5 mb-5 bg-light rounded">
            <h1>{{ request('category_id') }}</h1>
            <h3 class="mb-3">Search blogposts</h3>
            <form class="needs-validation" novalidate="" method="get" action="{{ url('blogposts/search') }}">
                <div class="row g-3">


                    <div class="col-12 col-md-6">
                        <label for="term" class="form-label">Search term(s)</label>
                        <input type="text" class="form-control" id="term" placeholder="" name="term"
                               value="{{ request('term') }}">
                    </div>

                    <div class="col-12 col-md-6">
                        <label for="tags" class="form-label">Containg at least 1 of following tags</label>
                        <input type="text" class="form-control" id="tags" placeholder="" name="tags"
                               value="{{ request('tags') }}">
                    </div>


                    <div class="col-12 col-md-6">
                        <label for="category" class="form-label">Category</label>
                        <select class="form-select" id="category" required="" name="category_id">
                            <option value="">any category</option>
                            @foreach($categories as $choseCategory)
                                @if (intval(request('category_id')) === $choseCategory->id)
                                    <option value="{{ $choseCategory->id }}" selected>{{ $choseCategory->title }}</option>
                                @else
                                    <option value="{{ $choseCategory->id }}">{{ $choseCategory->title }}</option>
                                @endif
                            @endforeach
                        </select>
                    </div>

                    <div class="col-12 col-md-6">
                        <label for="author" class="form-label">Author</label>
                        <select class="form-select" id="author" required="" name="author_id">
                            <option value="">any author</option>
                            @foreach($authors as $choseAuthor)
                                @if(intval(request('author_id')) === $choseAuthor->id)
                                    <option value="{{ $choseAuthor->id }}"
                                            selected>{{ $choseAuthor->full_name }}</option>
                                @else
                                    <option
                                        value="{{ $choseAuthor->id }}">{{ $choseAuthor->full_name }}</option>
                                @endif
                            @endforeach
                        </select>
                    </div>

                    <div class="col-12 col-md-6">
                        <label for="after" class="form-label">Blogposts after</label>
                        <input type="datetime-local" class="form-control" id="after" placeholder="" name="after"
                               value="{{ request('after') }}">
                    </div>

                    <div class="col-12 col-md-6">
                        <label for="before" class="form-label">Blogposts before</label>
                        <input type="datetime-local" class="form-control" id="before" placeholder="" name="before"
                               value="{{ request('before') }}">
                    </div>
                </div>


                <hr class="my-4">

                <div class="row g-3">
                    <div class="col-md-6">
                        <label for="sort" class="form-label">Sort by</label>
                        <select class="form-select" id="sort" required="" name="sort">
                            @foreach($sortArray as $key => $value)
                                @if(request('sort') === $key)
                                    <option value="{{ $key }}" selected>{{ $value }}</option>
                                @else
                                    <option value="{{ $key }}">{{ $value }}</option>
                                @endif
                            @endforeach
                        </select>
                    </div>


                </div>

                <hr class="my-4">

                <button class="btn btn-primary btn-lg" type="submit">Search</button>
            </form>

        </div>


        <div class="row mb-2">
            <h4 class="mb-4">
                <a id="results"></a>
                Search results
            </h4>
            @foreach($blogposts as $foundBlogpost)
                <div class="col-md-6">
                    <div
                        class="row g-0 border rounded overflow-hidden flex-md-row mb-4 shadow-sm h-md-250 position-relative">
                        <div class="col p-4 d-flex flex-column position-static">
                            <strong
                                class="d-inline-block mb-2 category-9">{{ $foundBlogpost->category->title }}</strong>
                            <h3 class="mb-0">{{ $foundBlogpost->title }}</h3>
                            <div class="mb-1 text-muted">{{ $foundBlogpost->created_at }}</div>
                            <p class="card-text mb-auto">{{ $foundBlogpost->content }}</p>
                            <a href="{{ url('blogposts/'.$foundBlogpost->id) }}" class="stretched-link">Continue
                                reading</a>
                        </div>
                        <div class="col-auto d-none d-lg-block img-container">
                            <img src="{{ asset('storage/'.$foundBlogpost->image) }}" alt="{{ $foundBlogpost->title }}"/>
                        </div>
                    </div>
                </div>
            @endforeach

            {{ $blogposts->links() }}

            <!--<nav>
                <ul class="pagination justify-content-center">
                    <li class="page-item disabled" aria-disabled="true" aria-label="&laquo; Previous">
                        <span class="page-link" aria-hidden="true">Previous</span>
                    </li>
                    <li class="page-item active" aria-current="page"><span class="page-link">1</span></li>
                    <li class="page-item"><a class="page-link" href="search?term=s&amp;sort=most_recent&amp;page=2#results">2</a></li>
                    <li class="page-item"><a class="page-link"
                                             href="search?term=s&amp;sort=most_recent&amp;page=3#results">3</a></li>
                    <li class="page-item"><a class="page-link"
                                             href="search?term=s&amp;sort=most_recent&amp;page=4#results">4</a></li>
                    <li class="page-item"><a class="page-link"
                                             href="search?term=s&amp;sort=most_recent&amp;page=5#results">5</a></li>
                    <li class="page-item"><a class="page-link"
                                             href="search?term=s&amp;sort=most_recent&amp;page=6#results">6</a></li>


                    <li class="page-item">
                        <a class="page-link" href="search?term=s&amp;sort=most_recent&amp;page=2#results" rel="next"
                           aria-label="Next &raquo;">Next</a>
                    </li>
                </ul>
            </nav>
            -->

        </div>

    </main>
@endsection

labo02/app/resources/views/sidebar.blade.php
<div class="col-md-4">
    <div class="position-sticky" style="top: 2rem;">
        <div class="p-4 mb-3 bg-light rounded">
            <h4 class="fst-italic">About</h4>
            <p class="mb-0">Customize this section to tell your visitors a little bit about your publication, writers, content, or something else entirely. Totally up to you.</p>
        </div>

        <div class="p-4">
            <h4 class="fst-italic">Most recent</h4>
            <ol class="list-unstyled mb-0">
                @foreach($recentBlogposts as $recentBlogpost)
                <li><a href="{{ url('blogposts/'.$recentBlogpost->id) }}" >{{ $recentBlogpost->title }}</a></li>
                @endforeach
            </ol>
        </div>

    </div>
</div>